summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorMichael Palimaka <kensington@gentoo.org>2020-04-20 18:24:03 +1000
committerMichael Palimaka <kensington@gentoo.org>2020-04-20 18:25:18 +1000
commit8bac76937d788fbb4b170f1114ab1cf294abc3df (patch)
tree08c3d3650d051cdb0787e752d57125cd15248304 /net-irc/unrealircd
parentdev-cpp/abseil-cpp: fix QA warning (diff)
downloadgentoo-8bac76937d788fbb4b170f1114ab1cf294abc3df.tar.gz
gentoo-8bac76937d788fbb4b170f1114ab1cf294abc3df.tar.bz2
gentoo-8bac76937d788fbb4b170f1114ab1cf294abc3df.zip
net-irc/unrealircd: version bump 5.0.4
Includes a systemd unit file Thanks-to: John Helmert III <jchelmertt3@gmail.com> Closes: https://bugs.gentoo.org/718382 Package-Manager: Portage-2.3.89, Repoman-2.3.22 Signed-off-by: Michael Palimaka <kensington@gentoo.org>
Diffstat (limited to 'net-irc/unrealircd')
-rw-r--r--net-irc/unrealircd/Manifest1
-rw-r--r--net-irc/unrealircd/files/unrealircd.service11
-rw-r--r--net-irc/unrealircd/unrealircd-5.0.4.ebuild171
3 files changed, 183 insertions, 0 deletions
diff --git a/net-irc/unrealircd/Manifest b/net-irc/unrealircd/Manifest
index 25676ead6283..3210cf1e4f10 100644
--- a/net-irc/unrealircd/Manifest
+++ b/net-irc/unrealircd/Manifest
@@ -1,2 +1,3 @@
DIST unrealircd-4.2.4.1.tar.gz 6090725 BLAKE2B 817a7c2a13a495944676d08ed90b36f6795fe43ee171efc6661980e6da9a8cc8d98c4fb0eb8221ac6af85ab1a9b5578a2e992d7b41696434430e58918bc30145 SHA512 752573c4af1f92a10739bb2b0cdaade1948207b46d28ae5177e1dfd6b0663044bc22dce5ffe8549882cd70325e3ef7e3296182fffbb84e08d59dbbdd6551a686
DIST unrealircd-5.0.3.1.tar.gz 4902967 BLAKE2B d3c2e2399091b3aa9906583231d5ba42534234c4c40ce7412609fe8866438848bb69a4fc3cd378e0ed9ab13970ba2a7b27ba9fccdaaaea3585ec0a05aa5f89c2 SHA512 1bf3e2aab2f14d68a02ae6925d9e91135a92cf08886f703be0cd203c8b4b323bfc3930254d2bda381e60b3991f379115c954fa1fd262e28d7a27172a25bb172a
+DIST unrealircd-5.0.4.tar.gz 4907069 BLAKE2B 223c45dbd060cf13afabafd13325bb76889fa64f663fff1be753de703df50265c6a05658edfe7300e97cf1431f54992b7e37801ef4773b02add9d5edca80237c SHA512 cdd83fa55bdf1960499fff48ba656b66cf5a1c43a360658bc37add217af36933f00280f7eaddcbbd39720058a401650b944a5f0ce79ae3ca6749bd58c9cd5241
diff --git a/net-irc/unrealircd/files/unrealircd.service b/net-irc/unrealircd/files/unrealircd.service
new file mode 100644
index 000000000000..5382670ef0a4
--- /dev/null
+++ b/net-irc/unrealircd/files/unrealircd.service
@@ -0,0 +1,11 @@
+[Unit]
+Description=Unrealircd IRC Server Daemon
+After=network.target
+
+[Service]
+Type=forking
+User=unrealircd
+ExecStart=/usr/bin/unrealircd
+
+[Install]
+WantedBy=multi-user.target
diff --git a/net-irc/unrealircd/unrealircd-5.0.4.ebuild b/net-irc/unrealircd/unrealircd-5.0.4.ebuild
new file mode 100644
index 000000000000..d2f7a8a96ec9
--- /dev/null
+++ b/net-irc/unrealircd/unrealircd-5.0.4.ebuild
@@ -0,0 +1,171 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+SSL_CERT_MANDATORY=1
+inherit ssl-cert systemd
+
+DESCRIPTION="An advanced Internet Relay Chat daemon"
+HOMEPAGE="https://www.unrealircd.org/"
+SRC_URI="https://www.unrealircd.org/downloads/${P}.tar.gz"
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="~amd64 ~ppc ~x86 ~amd64-linux"
+IUSE="class-nofakelag curl libressl +operoverride operoverride-verify +prefixaq showlistmodes"
+
+RDEPEND="
+ acct-group/unrealircd
+ acct-user/unrealircd
+ >=app-crypt/argon2-20171227-r1:=
+ dev-libs/libpcre2
+ >=net-dns/c-ares-1.7:=
+ !libressl? ( dev-libs/openssl:0= )
+ libressl? ( dev-libs/libressl:= )
+ curl? ( net-misc/curl[adns] )
+"
+DEPEND="${RDEPEND}"
+BDEPEND="virtual/pkgconfig"
+
+DOCS=( doc/{Authors,Donation,RELEASE-NOTES.md,tao.of.irc,technical/,translations.txt} )
+
+src_prepare() {
+ # QA check against bundled pkgs
+ rm -r extras || die
+
+ # building third-party modules (which we don't do) cause a sandbox violation
+ # bug 704444
+ echo "" > src/buildmod || die
+
+ if use class-nofakelag; then
+ sed -i -e 's:#undef\( FAKELAG_CONFIGURABLE\):#define\1:' include/config.h || die
+ fi
+
+ eapply_user
+}
+
+src_configure() {
+ # Default value for privatelibdir adds a build path to -Wl,-rpath.
+ econf \
+ --with-bindir="${EPREFIX}"/usr/bin \
+ --with-cachedir="${EPREFIX}"/var/lib/${PN} \
+ --with-confdir="${EPREFIX}"/etc/${PN} \
+ --with-datadir="${EPREFIX}"/var/lib/${PN} \
+ --with-docdir="${EPREFIX}"/usr/share/doc/${PF} \
+ --with-logdir="${EPREFIX}"/var/log/${PN} \
+ --with-modulesdir="${EPREFIX}"/usr/"$(get_libdir)"/${PN}/modules \
+ --without-privatelibdir \
+ --with-pidfile="${EPREFIX}"/run/${PN}/ircd.pid \
+ --with-tmpdir="${EPREFIX}"/var/lib/${PN}/tmp \
+ --with-maxconnections=1024 \
+ --with-nick-history=2000 \
+ --with-permissions=0640 \
+ --with-system-argon2 \
+ --with-system-cares \
+ --with-system-pcre2 \
+ --enable-dynamic-linking \
+ --enable-ssl="${EPREFIX}"/usr \
+ $(use_enable curl libcurl "${EPREFIX}"/usr) \
+ $(use_enable prefixaq) \
+ $(use_with showlistmodes) \
+ $(use_with !operoverride no-operoverride) \
+ $(use_with operoverride-verify)
+}
+
+src_install() {
+ keepdir /var/log/${PN}
+ keepdir /var/lib/${PN}/tmp
+
+ newbin src/ircd ${PN}
+
+ (
+ cd src/modules || die
+ for subdir in $(find . -type d -print); do
+ if [[ -n $(shopt -s nullglob; echo ${subdir}/*.so) ]]; then
+ exeinto /usr/$(get_libdir)/${PN}/modules/"${subdir}"
+ doexe "${subdir}"/*.so
+ fi
+ done
+ )
+
+ insinto /etc/${PN}
+ # Purposefully omitting the examples/ and ssl/ subdirectories. ssl
+ # is redundant with app-misc/ca-certificates and examples will all
+ # be in docs anyway.
+ doins -r doc/conf/{aliases,help}
+ doins doc/conf/*.conf
+ newins doc/conf/examples/example.conf ${PN}.conf
+ keepdir /etc/${PN}/tls
+
+ einstalldocs
+
+ newinitd "${FILESDIR}"/${PN}.initd-r2 ${PN}
+ newconfd "${FILESDIR}"/${PN}.confd-r3 ${PN}
+
+ # config should be read-only
+ fperms -R 0640 /etc/${PN}
+ fperms 0750 /etc/${PN}{,/aliases,/help}
+ fperms 0750 /etc/${PN}/tls
+ # state is editable but not owned by unrealircd directly
+ fperms 0770 /var/log/${PN}
+ fperms 0770 /var/lib/${PN}{,/tmp}
+ fowners -R root:unrealircd /{etc,var/{lib,log}}/${PN}
+
+ # By default looks in /etc/unrealircd/ssl/curl-ca-bundle.crt. Fix
+ # that to look for ca-certificates-provided file instead. %s is
+ # CONFDIR. #618066
+ dosym ../../ssl/certs/ca-certificates.crt /etc/${PN}/tls/curl-ca-bundle.crt
+
+ insinto $(systemd_get_systemunitdir)
+ doins "${FILESDIR}"/${PN}.service
+}
+
+pkg_postinst() {
+ # Move docert call from src_install() to install_cert in pkg_postinst for
+ # bug #201682
+ if [[ ! -f "${EROOT}"/etc/${PN}/tls/server.cert.key ]]; then
+ if [[ -f "${EROOT}"/etc/${PN}/ssl/server.cert.key ]]; then
+ ewarn "The location ${PN} looks for SSL certificates has changed"
+ ewarn "from ${EROOT}/etc/${PN}/ssl to ${EROOT}/etc/${PN}/tls."
+ ewarn "Please move your existing certificates."
+ else
+ (
+ umask 0037
+ install_cert /etc/${PN}/tls/server.cert
+ chown unrealircd "${EROOT}"/etc/${PN}/tls/server.cert.*
+ ln -snf server.cert.key "${EROOT}"/etc/${PN}/tls/server.key.pem
+ )
+ fi
+ fi
+
+ local unrealircd_conf="${EROOT}"/etc/${PN}/${PN}.conf
+ # Fix up the default cloak keys.
+ if grep -qe '"and another one";$' "${unrealircd_conf}" && grep -qe '"aoAr1HnR6gl3sJ7hVz4Zb7x4YwpW";$' "${unrealircd_conf}"; then
+ ebegin "Generating cloak-keys"
+ local keys=(
+ $(su ${PN} -s /bin/sh -c "${PN} -k 2>&1 | tail -n 3")
+ )
+ [[ -n ${keys[0]} || -n ${keys[1]} || -n ${keys[2]} ]]
+ eend $?
+
+ ebegin "Substituting cloak-keys into ${unrealircd_conf}"
+ sed -i \
+ -e '/cloak-keys/ {
+n
+s/"aoAr1HnR6gl3sJ7hVz4Zb7x4YwpW";/"'"${keys[0]}"'";/
+n
+s/"and another one";/"'"${keys[1]}"'";/
+n
+s/"and another one";/"'"${keys[2]}"'";/
+}' \
+ "${unrealircd_conf}"
+ eend $?
+ fi
+
+ elog "UnrealIRCd will not run until you've set up /etc/unrealircd/unrealircd.conf"
+ elog
+ elog "You can also configure ${PN} start at boot with rc-update(1)."
+ elog "It is recommended to run unrealircd as an unprivileged user."
+ elog "The provided init.d script does this for you."
+}